//+------------------------------------------------------------------+
//|                                                       Series.mqh |
//|                                 Copyright 2015, Vasiliy Sokolov. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Vasiliy Sokolov."
#property link      "http://www.mql5.com"
//+------------------------------------------------------------------+
//|       .     |
//+------------------------------------------------------------------+
class CSeries
  {
protected:
   string            m_symbol;
   ENUM_TIMEFRAMES   m_timeframe;
                     CSeries(void);
public:
   string            Symbol(void);
   ENUM_TIMEFRAMES   Timeframe(void);
   void              Symbol(string symbol);
   void              Timeframe(ENUM_TIMEFRAMES tf);
   int               Total(void);
  };
//+------------------------------------------------------------------+
//|   .                                        |
//+------------------------------------------------------------------+
CSeries::CSeries(void)
  {
  }
//+------------------------------------------------------------------+
//|   .                                         |
//+------------------------------------------------------------------+
string CSeries::Symbol(void)
  {
   return m_symbol;
  }
//+------------------------------------------------------------------+
//|   .                                      |
//+------------------------------------------------------------------+
void CSeries::Symbol(string symbol)
  {
   m_symbol=symbol;
  }
//+------------------------------------------------------------------+
//|   .                                |
//+------------------------------------------------------------------+
ENUM_TIMEFRAMES CSeries::Timeframe(void)
  {
   return m_timeframe;
  }
//+------------------------------------------------------------------+
//|   .                             |
//+------------------------------------------------------------------+
void CSeries::Timeframe(ENUM_TIMEFRAMES tf)
  {
   m_timeframe=tf;
  }
//+------------------------------------------------------------------+
//|    .                           |
//+------------------------------------------------------------------+
int CSeries::Total(void)
  {
   return Bars(m_symbol, m_timeframe);
  }
//+------------------------------------------------------------------+
//|        . |
//+------------------------------------------------------------------+
class COpen : public CSeries
  {
public:
   double operator[](int index)
     {
      double value[];
      if(CopyOpen(m_symbol, m_timeframe, index, 1, value) == 0)return 0.0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                    |
//+------------------------------------------------------------------+
class CHigh : public CSeries
  {
public:
   double operator[](int index)
     {
      double value[];
      if(CopyHigh(m_symbol, m_timeframe, index, 1, value) == 0)return 0.0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                     |
//+------------------------------------------------------------------+
class CLow : public CSeries
  {
public:
   double operator[](int index)
     {
      double value[];
      if(CopyLow(m_symbol, m_timeframe, index, 1, value) == 0)return 0.0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                        |
//+------------------------------------------------------------------+
class CClose : public CSeries
  {
public:
   double operator[](int index)
     {
      double value[];
      if(CopyClose(m_symbol, m_timeframe, index, 1, value) == 0)return 0.0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                      |
//+------------------------------------------------------------------+
class CVolume : public CSeries
  {
public:
   long operator[](int index)
     {
      long value[];
      if(CopyRealVolume(m_symbol, m_timeframe, index, 1, value) == 0)return 0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|      .                       |
//+------------------------------------------------------------------+
class CTickVolume : public CSeries
  {
public:
   long operator[](int index)
     {
      long value[];
      if(CopyTickVolume(m_symbol, m_timeframe, index, 1, value) == 0)return 0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
//|     .                                 |
//+------------------------------------------------------------------+
class CTime : public CSeries
  {
public:
   datetime operator[](int index)
     {
      datetime value[];
      if(CopyTime(m_symbol, m_timeframe, index, 1, value) == 0)return 0;
      return value[0];
     }
  };
//+------------------------------------------------------------------+
